echo "========================================================="
echo "Sniffy firmware updater"
echo "(c) 2022 SDR Engineering - onderdeel van Solardoctor B.V."
echo "========================================================="
echo ""
echo "Steps to update:"
echo "1) Connect module to 12V power, and connect the USB of the module with your computer."
echo "2) Wait for your computer to install the appropriate USB drivers for the device."
echo "3) Hold the programming button pressed (located next to the USB port), and briefly press the reset button while holding."
echo "   The LED should go to a very dim green. Release all buttons, the module is now in firmware update mode."
echo "4) Press [ENTER] to start flashing, or enter the COM-port to skip the search."
echo "5) The updater will search for the correct COM-port, and might try them all. Just have some patience."
echo ""
echo "Warning: updating the firmware will erase the configuration of the module."
echo "Warning: do not disconnect the module from 12V power or from your computer while updating"
echo "Warning: this firmware updater is only compatible with board version R05 and later"
echo ""
echo ""

read -p "Press [ENTER] to continue..." </dev/tty

if ! which esptool.py &> /dev/null; then
    echo "Note: esptool.py not found. Installing..."
    pip install esptool
fi


echo "Updating firmware..."
esptool.py --chip esp32 --baud 921600 --before usb_reset --after hard_reset write_flash --flash_mode dio --flash_freq 80m --flash_size 4MB 0x0000 ./firmware.bin

echo "Done."


